# Reference

**Contents**

```@contents
Pages = ["reference.md"]
```

## Core Layers

```@docs
KnetLayers.Multiply
KnetLayers.Embed   
KnetLayers.Linear   
KnetLayers.Dense   
KnetLayers.BatchNorm   
```

## Nonlinearities

```@docs
KnetLayers.ReLU   
KnetLayers.Sigm   
KnetLayers.Tanh   
KnetLayers.ELU   
KnetLayers.LeakyReLU   
KnetLayers.Dropout   
KnetLayers.SoftMax   
KnetLayers.LogSoftMax   
KnetLayers.LogSumExp   
```

## Loss Functions

```@docs
KnetLayers.CrossEntropyLoss
KnetLayers.BCELoss
KnetLayers.LogisticLoss
```

## Convolutional Layers
```@docs
KnetLayers.Conv   
KnetLayers.DeConv   
KnetLayers.Pool   
KnetLayers.UnPool  
```

## Recurrent Layers

```@docs
KnetLayers.AbstractRNN  
KnetLayers.RNNOutput
KnetLayers.PadSequenceArray
KnetLayers.PadRNNOutput
```

## Special Layers

```@docs
KnetLayers.MLP   
```

## Function Index

```@index
Pages = ["reference.md"]
```
